<?php
/**
 * @package     HSFirePHP!
 * @author      Hosting Skills a.s.b.l. - https://www.hosting-skills.lu
 * @copyright   Copyright (C) 2014-2021 Hosting Skills a.s.b.l.. All rights reserved.
 * @license     GNU/GPLv3 https://www.gnu.org/licenses/gpl-3.0.html
 */

defined('_JEXEC') or die;

/**
 * Sends the given data to the FirePHP Firefox Extension.
 * The data can be displayed in the Firefox Web Console.
 *
 * @return  boolean  TRUE
 *
 * @throws  Exception
 *
 * @since   1.1.0
 */
function fb(): bool
{
	return true;
}

class FB {
	/**
	 * Set an Insight console to direct all logging calls to
	 *
	 * @param   object  $console  The console object to log to
	 *
	 * @return  void
	 *
	 * @throws  Exception
	 *
	 * @since   1.5.0
	 */
	public static function setLogToInsightConsole(object $console)
	{
	}

	/**
	 * Enable and disable logging to Firefox Web Console
	 *
	 * @param   boolean  $enabled  TRUE to enable, FALSE to disable
	 *
	 * @return  void
	 *
	 * @throws  Exception
	 *
	 * @since   1.1.0
	 */
	public static function setEnabled(bool $enabled)
	{
	}

	/**
	 * Check if logging is enabled
	 *
	 * @return  boolean  TRUE if enabled
	 *
	 * @since   1.1.0
	 */
	public static function getEnabled(): bool
	{
		return false;
	}

	/**
	 * Specify a filter to be used when encoding an object
	 *
	 * Filters are used to exclude object members.
	 *
	 * @param   string  $class   The class name of the object
	 * @param   array   $filter  An array or members to exclude
	 *
	 * @return  void
	 *
	 * @throws  Exception
	 *
	 * @since   1.1.0
	 */
	public static function setObjectFilter(string $class, array $filter)
	{
	}

	/**
	 * Set some options for the library
	 *
	 * @param   array  $options  The options to be set
	 *
	 * @return  void
	 *
	 * @throws  Exception
	 *
	 * @since   1.1.0
	 */
	public static function setOptions(array $options)
	{
	}

	/**
	 * Get options for the library
	 *
	 * @return  array  The options
	 *
	 * @since   1.1.0
	 */
	public static function getOptions(): array
	{
		return array();
	}

	/**
	 * Log object to Firefox Web Console
	 *
	 * @return  boolean  TRUE
	 *
	 * @since   1.1.0
	 */
	public static function send(): bool
	{
		return true;
	}

	/**
	 * Start a group for following messages
	 *
	 * Options:
	 *   Collapsed: [true|false]
	 *   Color:     [#RRGGBB|ColorName]
	 *
	 * @param   string      $name
	 * @param   array|null  $options  optional  Instructions on how to log the group
	 *
	 * @return  boolean  TRUE
	 *
	 * @throws  Exception
	 *
	 * @since   1.1.0
	 */
	public static function group(string $name, array $options = null): bool
	{
		return true;
	}

	/**
	 * Ends a group you have started before
	 *
	 * @return  boolean  TRUE
	 *
	 * @throws  Exception
	 *
	 * @since   1.1.0
	 */
	public static function groupEnd(): bool
	{
		return true;
	}

	/**
	 * Log object with label to Firefox Web Console
	 *
	 * @param   mixed        $object
	 * @param   string|null  $label
	 *
	 * @return  boolean  TRUE
	 *
	 * @throws  Exception
	 *
	 * @since   1.1.0
	 */
	public static function log($object, string $label = null): bool
	{
		return true;
	}

	/**
	 * Log object with label to Firefox Web Console
	 *
	 * @param   mixed        $object
	 * @param   string|null  $label
	 *
	 * @return  boolean  TRUE
	 *
	 * @throws  Exception
	 *
	 * @since   1.1.0
	 */
	public static function info($object, string $label = null): bool
	{
		return true;
	}

	/**
	 * Log object with label to Firefox Web Console
	 *
	 * @param   mixed        $object
	 * @param   string|null  $label
	 *
	 * @return  boolean  TRUE
	 *
	 * @throws  Exception
	 *
	 * @since   1.1.0
	 */
	public static function warn($object, string $label = null): bool
	{
		return true;
	}

	/**
	 * Log object with label to Firefox Web Console
	 *
	 * @param   mixed        $object
	 * @param   string|null  $label
	 *
	 * @return  boolean  TRUE
	 *
	 * @throws  Exception
	 *
	 * @since   1.1.0
	 */
	public static function error($object, string $label = null): bool
	{
		return true;
	}

	/**
	 * Dumps key and variable to Firefox Web Console
	 *
	 * @param   string  $key
	 * @param   mixed   $variable
	 *
	 * @return  boolean  TRUE
	 *
	 * @throws  Exception
	 *
	 * @since   1.1.0
	 */
	public static function dump(string $key, $variable): bool
	{
		return true;
	}

	/**
	 * Log a trace in the Firefox Web Console
	 *
	 * @param   string  $label
	 *
	 * @return  boolean  TRUE
	 *
	 * @throws  Exception
	 *
	 * @since   1.1.0
	 */
	public static function trace(string $label): bool
	{
		return true;
	}

	/**
	 * Log a table in the Firefox Web Console
	 *
	 * @param   string  $label
	 * @param   string  $table
	 *
	 * @return  boolean  TRUE
	 *
	 * @throws  Exception
	 *
	 * @since   1.1.0
	 */
	public static function table(string $label, string $table): bool
	{
		return true;
	}

	/**
	 * Queue using JSession
	 *
	 * @return  void
	 *
	 * @throws  Exception
	 *
	 * @since   1.1.0
	 */
	private static function queue()
	{
	}

	/**
	 * FirePHP's error handler
	 *
	 * Throws exception for each php error that will occur.
	 *
	 * @param   integer  $errno
	 * @param   string   $errstr
	 * @param   string   $errfile
	 * @param   integer  $errline
	 *
	 * @return  void
	 *
	 * @throws  Exception
	 *
	 * @since   1.1.0
	 */
	public static function errorHandler(int $errno, string $errstr, string $errfile, int $errline)
	{
	}

	/**
	 * FirePHP's exception handler
	 *
	 * Logs all exceptions to your Firefox Web Console and then stops the script.
	 *
	 * @param   Exception  $exception
	 *
	 * @return  void
	 *
	 * @throws  Exception
	 *
	 * @since   1.1.0
	 */
	public static function exceptionHandler(Exception $exception)
	{
	}

	/**
	 * FirePHP's assertion handler
	 *
	 * Logs all assertions to your Firefox Web Console and then stops the script.
	 *
	 * @param   string       $file  File source of assertion
	 * @param   integer      $line  Line source of assertion
	 * @param   mixed        $code  Assertion code
	 * @param   string|null  $desc  Assertion description
	 *
	 * @return  void
	 *
	 * @throws  Exception
	 *
	 * @since   1.1.0
	 */
	public static function assertionHandler(string $file, int $line, $code, string $desc = null)
	{
	}
}